from typing import TYPE_CHECKING, Any, Dict, List, Type, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

if TYPE_CHECKING:
    from ..models.output_data_output_tables_type_0_additional_property import (
        OutputDataOutputTablesType0AdditionalProperty,
    )


T = TypeVar("T", bound="OutputDataOutputTablesType0")


@_attrs_define
class OutputDataOutputTablesType0:
    """Set only if the RunStatus equals Done. Will contain all of the output data for that run, or a single table if
    requested, in the format:

        Example:
            {'TableName1': {'ColumnName1': ['Value1', 'Value2', '...', 'ValueK'], 'ColumnName2': ['Value1', 'Value2', '...',
                'ValueK']}, 'TableName2': {'ColumnName1': ['Value1', 'Value2', '...', 'ValueL'], 'ColumnName2': ['Value1',
                'Value2', '...', 'ValueL'], 'ColumnName3': ['Value1', 'Value2', '...', 'ValueL']}, 'TableName3': {'ColumnName1':
                ['Value1', 'Value2', '...', 'ValueM']}}

    """

    additional_properties: Dict[str, "OutputDataOutputTablesType0AdditionalProperty"] = _attrs_field(
        init=False, factory=dict
    )

    def to_dict(self) -> Dict[str, Any]:
        field_dict: Dict[str, Any] = {}
        for prop_name, prop in self.additional_properties.items():
            field_dict[prop_name] = prop.to_dict()

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        from ..models.output_data_output_tables_type_0_additional_property import (
            OutputDataOutputTablesType0AdditionalProperty,
        )

        d = src_dict.copy()
        output_data_output_tables_type_0 = cls()

        additional_properties = {}
        for prop_name, prop_dict in d.items():
            additional_property = OutputDataOutputTablesType0AdditionalProperty.from_dict(prop_dict)

            additional_properties[prop_name] = additional_property

        output_data_output_tables_type_0.additional_properties = additional_properties
        return output_data_output_tables_type_0

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> "OutputDataOutputTablesType0AdditionalProperty":
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: "OutputDataOutputTablesType0AdditionalProperty") -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
